function [x,h] = newtonSearchAlgorithm(b,n,tol)
% Given, "a", this function finds the nth root of a
% number by finding where: x^n-a=0.

coder.inline('never');

    notDone = 1;
    aNew    = 0; %Refined Guess Initialization
    a       = 1; %Initial Guess
    cnt     = 0;
    h = zeros(1,50);
    h(1)=a;
    while notDone
        cnt = cnt+1;
        [curVal,slope] = f_and_df(a,b,n); %square
        yint = curVal-slope*a;
        aNew = -yint/slope; %The new guess
        h(cnt)=aNew;
        if (abs(aNew-a) < tol) %Break if it's converged
            notDone = 0;
        elseif cnt>49 %after 50 iterations, stop
            notDone = 0;
            aNew = 0;
        else
            a = aNew;
        end
    end
    x = aNew;
    
function [f,df] = f_and_df(a,b,n)
% Our function is f=a^n-b and it's derivative is n*a^(n-1).

    f  = a^n-b;
    df = n*a^(n-1);
